/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
*/

#include "minigui.ch"
#include "metrocolor.ch"

#define PATH_START   GetStartUpFolder()
#define PATH_BACKUP  GetCurrentFolder() + "\BACKUP\"  

/////////////////////////////////////////////////////////////////////////
//   
FUNCTION MyEditSuperHeader()
   LOCAL cIco  := "MG128", cTitle := ""
   LOCAL cFont := 'Tahoma', nFontSize := ModeSizeFont()
   LOCAL aBackColor := COLOR_YELLOW_METRO  //    
   LOCAL cIco1x1, cIco1x2, cIco2x1, cIco2x2, cIco3x1, cIco3x2
   LOCAL aFButtColor1 := WHITE, aFButtColor2 := BLACK
   LOCAL hWnd, nMaxHeight, nMaxWidth, nRow, nCol, nColButt
   LOCAL nHButt, cButtCapt, nRowButt, nFButtSize := nFontSize-2
   LOCAL nWButt, nWText, lRet, cPath1, cPath2, aFile, aDim
   LOCAL cF, aGFile, lPrg, lCh, lC, lRc, lLib, lBak, lDbf, cPathPrj

    IF M->nPubLang == 1
      aGFile := { {" (hbp,hbc)"    , "*.hbp;*.hbc"}, ; 
                  {" (.bc)"        , "*.bc"       }, ;
                  {"  (.lst)", "*.lst"      }, ; 
                  {" "            , "*.*"        }  }  
    ELSE
      aGFile := { {"Projects (hbp,hbc)"   , "*.hbp;*.hbc"}, ; 
                  {"Projects (.bc)"       , "*.bc"       }, ;
                  {"Listing files (.lst)" , "*.lst"      }, ; 
                  {"All files"            , "*.*"        }  }  
    ENDIF

   //    HbpMerge.cnfg
   MyConfigLoad(@cPath1,@cPath2,@cPathPrj,@lPrg,@lCh,@lC,@lRc,@lLib,@lBak,@lDbf)

   DEFINE WINDOW Form_Cnfg              ;
          At 0, 0                       ;
          WIDTH 760 HEIGHT 650          ;
          TITLE cTitle                  ;
          ICON cIco                     ;
          MODAL                         ;
          NOSIZE                        ;
          FONT cFont SIZE nFontSize     ;
          BACKCOLOR aBackColor          ;
          ON INIT MyChangeObjLang() 

      hWnd := GetFormHandle('Form_Cnfg') 
      nMaxWidth  := GetClientWidth(hWnd)   
      nMaxHeight := GetClientHeight(hWnd)

      @ 0, 0 LABEL Buff WIDTH 10 HEIGHT 10 VALUE '' TRANSPARENT 

      nCol := 20
      nRow := 20 
      @ nRow, nCol FRAME Frame_1  CAPTION "    (1) " ;
        WIDTH nMaxWidth-nCol*2 HEIGHT 100 BACKCOLOR aBackColor //OPAQUE        

      @ nRow + 30, nCol+10 BUTTONEX BUTTON_1 WIDTH 60 HEIGHT 60  ;
        CAPTION '' ICON "iFolder48"        ; 
        BACKCOLOR COLOR_BRIGHT_GREY        ;
        NOXPSTYLE HANDCURSOR NOTABSTOP     ;
        ACTION  {|| cPath1 := GetFolder("Open folder (1)",cPath1), ;
                    Form_Cnfg.TextBox_1.Value := cPath1, ; 
                    Form_Cnfg.Textbox_1.Setfocus                }

      @ nRow + 40, nCol + 60 + 10*2 TEXTBOX TextBox_1 VALUE cPath1 ;
        WIDTH nMaxWidth-nCol*2 - 60 - 10*2 - 20 HEIGHT nFontSize*2 ;
        FONTCOLOR RED BACKCOLOR {255,255,255} ;
        ON CHANGE {|| cPath1 := Form_Cnfg.TextBox_1.Value }

      nRow := Form_Cnfg.Frame_1.Row + Form_Cnfg.Frame_1.Height + 20 
      @ nRow, nCol FRAME Frame_2  CAPTION "    (2) " ;
        WIDTH nMaxWidth-nCol*2 HEIGHT 100 BACKCOLOR aBackColor //OPAQUE        

      @ nRow + 30, nCol+10 BUTTONEX BUTTON_2 WIDTH 60 HEIGHT 60  ;
        CAPTION '' ICON "iFolder48"        ; 
        BACKCOLOR COLOR_BRIGHT_GREY        ;
        NOXPSTYLE HANDCURSOR NOTABSTOP     ;
        ACTION  {|| cPath2 := GetFolder("Open folder (2)",cPath2), ;
                    Form_Cnfg.TextBox_2.Value := cPath2, ; 
                    Form_Cnfg.Textbox_2.Setfocus             }

      @ nRow + 40, nCol + 60 + 10*2 TEXTBOX TextBox_2 VALUE cPath2 ;
        WIDTH nMaxWidth-nCol*2 - 60 - 10*2 - 20 HEIGHT nFontSize*2 ;
        FONTCOLOR RED BACKCOLOR {255,255,255} ;
        ON CHANGE {|| cPath2 := Form_Cnfg.TextBox_2.Value }

      nRow := Form_Cnfg.Frame_2.Row + Form_Cnfg.Frame_2.Height + 20 
      @ nRow, nCol FRAME Frame_3  CAPTION "    list- " ;
        WIDTH nMaxWidth-nCol*2 HEIGHT 100 BACKCOLOR aBackColor //OPAQUE        

      @ nRow + 30, nCol+10 BUTTONEX BUTTON_3 WIDTH 60 HEIGHT 60  ;
        CAPTION '' ICON "iProjct48"        ; 
        BACKCOLOR COLOR_BRIGHT_GREY        ;
        NOXPSTYLE HANDCURSOR NOTABSTOP     ;
        ACTION  {|| aDim := Getfile ( aGFile , 'Open File(s)' , cPathPrj , .t. , .t. ),;
                         cF := "", aEval(aDim, {|x,e| cF += x + " " } ) ,;
                         Form_Cnfg.Textbox_3.Value := cF , aFile := aDim, ;
                         Form_Cnfg.Textbox_3.Setfocus }

      @ nRow + 40, nCol + 60 + 10*2 TEXTBOX TextBox_3 VALUE cPathPrj ;
        WIDTH nMaxWidth-nCol*2 - 60 - 10*2 - 20 HEIGHT nFontSize*2 ;
        FONTCOLOR BLUE BACKCOLOR {255,255,255} ;
        ON CHANGE {|| cPathPrj := Form_Cnfg.TextBox_3.Value }

      nRow := Form_Cnfg.Frame_3.Row + Form_Cnfg.Frame_3.Height + 20 
      @ nRow, nCol FRAME Frame_4  CAPTION "      " ;
        WIDTH nMaxWidth-nCol*2 HEIGHT 100 BACKCOLOR aBackColor         

      nWText := GetTxtWidth( ".prg", nFontSize, cFont) 
      @ nRow + 30, nCol + 20 CHECKBOX Check_1            ;
        CAPTION ".prg" VALUE lPrg                        ;
        WIDTH nWText+20 HEIGHT nFontSize*2 BACKCOLOR aBackColor ;
        ON CHANGE {|| lPrg := GetProperty(ThisWindow.Name, This.Name, "Value" ) }

      nCol := Form_Cnfg.Check_1.Col + Form_Cnfg.Check_1.Width + 15
      nWText := GetTxtWidth(".ch", nFontSize, cFont) 
      @ nRow + 30, nCol CHECKBOX Check_2                 ;
        CAPTION ".ch" VALUE lCh                          ;
        WIDTH nWText+20 HEIGHT nFontSize*2 BACKCOLOR aBackColor ;
        ON CHANGE {|| lCh := GetProperty(ThisWindow.Name, This.Name, "Value" ) }

      nCol := Form_Cnfg.Check_2.Col + Form_Cnfg.Check_2.Width + 15
      nWText := GetTxtWidth(".c", nFontSize, cFont) 
      @ nRow + 30, nCol CHECKBOX Check_3                 ;
        CAPTION ".c" VALUE lC                            ;
        WIDTH nWText+20 HEIGHT nFontSize*2 BACKCOLOR aBackColor ;
        ON CHANGE {|| lC := GetProperty(ThisWindow.Name, This.Name, "Value" ) }

      nCol := Form_Cnfg.Check_3.Col + Form_Cnfg.Check_3.Width + 15
      nWText := GetTxtWidth(".rc", nFontSize, cFont) 
      @ nRow + 30, nCol CHECKBOX Check_4                 ;
        CAPTION ".rc" VALUE lRc                          ;
        WIDTH nWText+20 HEIGHT nFontSize*2 BACKCOLOR aBackColor ;
        ON CHANGE {|| lRc := GetProperty(ThisWindow.Name, This.Name, "Value" ) }

      nCol := Form_Cnfg.Check_4.Col + Form_Cnfg.Check_4.Width + 15
      nWText := GetTxtWidth(".lib", nFontSize, cFont) 
      @ nRow + 30, nCol CHECKBOX Check_5                 ;
        CAPTION ".lib" VALUE lLib                        ;
        WIDTH nWText+20 HEIGHT nFontSize*2 BACKCOLOR aBackColor ;
        ON CHANGE {|| lLib := GetProperty(ThisWindow.Name, This.Name, "Value" ) }

      nCol := Form_Cnfg.Check_5.Col + Form_Cnfg.Check_5.Width + 15
      nWText := GetTxtWidth(".bak", nFontSize, cFont) 
      @ nRow + 30, nCol CHECKBOX Check_6                 ;
        CAPTION ".bak" VALUE lBak                        ;
        WIDTH nWText+20 HEIGHT nFontSize*2 BACKCOLOR aBackColor ;
        ON CHANGE {|| lBak := GetProperty(ThisWindow.Name, This.Name, "Value" ) }

      nCol := Form_Cnfg.Check_6.Col + Form_Cnfg.Check_6.Width + 15
      nWText := GetTxtWidth(".dbf", nFontSize, cFont) 
      @ nRow + 30, nCol CHECKBOX Check_7                 ;
        CAPTION ".dbf" VALUE lDbf                        ;
        WIDTH nWText+20 HEIGHT nFontSize*2 BACKCOLOR aBackColor ;
        ON CHANGE {|| lDbf := GetProperty(ThisWindow.Name, This.Name, "Value" ) }

      /////////////////////// Button ////////////////////////////
      nWButt := 240  //    
      nHButt := 80   //   
      nRowButt := nMaxHeight - nHButt - 20 //    
      nColButt := ( nMaxWidth - nHButt - nWButt*2 )/4

      //   nHButt  nHButt
        cIco1x1 := "iHelp48x1"  ;  cIco1x2 := "iHelp48x2"
        @ nRowButt, nColButt BUTTONEX BUTTON_Help WIDTH nHButt HEIGHT nHButt  ;
           CAPTION ''             ;
           ICON cIco1x1           ; 
           FONTCOLOR aFButtColor1 ;
           BACKCOLOR COLOR_BLUE_SKYPE ;
           SIZE nFButtSize BOLD   ;
           NOXPSTYLE HANDCURSOR   ;
           ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", cIco1x2 ) ,;
                           SetProperty(ThisWindow.Name, This.Name, "fontcolor", aFButtColor2 ) ) ;
           ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", cIco1x1 ) ,;
                           SetProperty(ThisWindow.Name, This.Name, "fontcolor", aFButtColor1 ) ) ;
           ACTION {|| MyHelp(), Form_Cnfg.Buff.Setfocus } ;
           NOTABSTOP        


        cButtCapt := "" + CRLF + "" 
        nCol := nColButt + nHButt  + nColButt
        cIco2x1 := "iFloppy48x1"  ;  cIco2x2 := "iFloppy48x2"
        @ nRowButt, nCol BUTTONEX BUTTON_Save  WIDTH nWButt HEIGHT nHButt  ;
           CAPTION cButtCapt      ;
           ICON cIco2x1           ; 
           FONTCOLOR aFButtColor1 ;
           BACKCOLOR COLOR_BRIGHT_GREEN ;
           SIZE nFButtSize BOLD   ;
           NOXPSTYLE HANDCURSOR   ;
           ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", cIco2x2 ) ,;
                           SetProperty(ThisWindow.Name, This.Name, "fontcolor", aFButtColor2 ) ) ;
           ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", cIco2x1 ) ,;
                           SetProperty(ThisWindow.Name, This.Name, "fontcolor", aFButtColor1 ) ) ;
           ACTION {|| lRet := .T., MyConfigSave(), ThisWindow.Release } ;
           NOTABSTOP        

        cButtCapt := "" 
        nCol := nColButt + nHButt  + nColButt + nWButt + nColButt
        cIco3x1 := "iCancel48x1"  ;  cIco3x2 := "iCancel48x2"
        @ nRowButt, nCol BUTTONEX BUTTON_Exit  WIDTH nWButt HEIGHT nHButt  ;
           CAPTION cButtCapt      ;
           ICON cIco3x1           ; 
           FONTCOLOR aFButtColor1 ;
           BACKCOLOR RED          ;
           SIZE nFButtSize BOLD   ;
           NOXPSTYLE HANDCURSOR   ;
           ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", cIco3x2 ) ,;
                           SetProperty(ThisWindow.Name, This.Name, "fontcolor", aFButtColor2 ) ) ;
           ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", cIco3x1 ) ,;
                           SetProperty(ThisWindow.Name, This.Name, "fontcolor", aFButtColor1 ) ) ;
           ACTION { || lRet:=.F., ThisWindow.Release } ;
           NOTABSTOP        

     ON KEY ESCAPE ACTION ThisWindow.Release

   END WINDOW


CENTER WINDOW Form_Cnfg
ACTIVATE WINDOW Form_Cnfg

RETURN lRet


/////////////////////////////////////////////////////////////////////////
FUNCTION MyChangeObjLang()

   IF M->nPubLang # 1
      Form_Cnfg.Frame_1.Caption := "The path to the folder (1)"
      Form_Cnfg.Frame_2.Caption := "The path to the folder (2)"
      Form_Cnfg.Frame_3.Caption := "File or project list-file"
      Form_Cnfg.Frame_4.Caption := "Handling of file types within the project"
      Form_Cnfg.Button_Save.Caption := "Save" + CRLF + "configuration"
      Form_Cnfg.Button_Exit.Caption := "Cancel"
   ENDIF

RETURN NIL
/////////////////////////////////////////////////////////////////////////
FUNCTION MyHelp()
   LOCAL cMsg

   cMsg := Replicate( "-._.", 22 ) + CRLF + CRLF
   IF M->nPubLang == 1
      cMsg += ' " 1" -    ' + CRLF + CRLF 
      cMsg += ' " 2" -    ' + CRLF + CRLF 
      cMsg += ' "   list-" -       .' + CRLF + CRLF 
      cMsg += '   MyProject.lst       .prg, .ch, .c, .bak, .dbf, ...   CRLF' + CRLF + CRLF 
   ELSE
      cMsg += ' "Folder 1" - the main folder of the project' + CRLF + CRLF
      cMsg += ' "Folder 2" - the selective part of the project' + CRLF + CRLF
      cMsg += ' "The project file or list-file" - project file which compares the contents between folders.' + CRLF + CRLF
      cMsg += 'You can create a file and MyProject.lst it simply enumerate a list of .prg, .ch, .c, .bak, .dbf, ... through CRLF' + CRLF + CRLF
   ENDIF
   cMsg += Replicate( "-._.", 22 ) + CRLF + CRLF
   MsgInfo(cMsg,IIF(M->nPubLang == 1,"","Help") )

RETURN NIL

/////////////////////////////////////////////////////////////////////////
FUNCTION MyConfigSave()
   LOCAL aDim := {}

   AADD( aDim, Form_Cnfg.Textbox_1.Value ) //    1
   AADD( aDim, Form_Cnfg.Textbox_2.Value ) //    2
   AADD( aDim, Form_Cnfg.Textbox_3.Value ) //  
   AADD( aDim, Form_Cnfg.Check_1.Value   ) //  .prg
   AADD( aDim, Form_Cnfg.Check_2.Value   ) //  .ch
   AADD( aDim, Form_Cnfg.Check_3.Value   ) //  .c
   AADD( aDim, Form_Cnfg.Check_4.Value   ) //  .rc
   AADD( aDim, Form_Cnfg.Check_5.Value   ) //  .lib
   AADD( aDim, Form_Cnfg.Check_6.Value   ) //  .bak
   AADD( aDim, Form_Cnfg.Check_7.Value   ) //  .dbf
 
   IniSetFilesCnf("", "", "FilesProcessing", aDim)

RETURN NIL

/////////////////////////////////////////////////////////////////////////
FUNCTION MyConfigLoad(cPath1,cPath2,cPathPrj,lPrg,lCh,lC,lRc,lLib,lBak,lDbf)
   LOCAL aDim:={}

   aDim := IniGetFilesCnf("", "", "FilesProcessing") //  

   cPath1   := aDim[1]
   cPath2   := aDim[2]
   cPathPrj := aDim[3]
   lPrg     := aDim[4]
   lCh      := aDim[5]
   lC       := aDim[6]
   lRc      := aDim[7]
   lLib     := aDim[8]
   lBak     := aDim[9]
   lDbf     := aDim[10]
   //MsgDebug(aDim)

   IF LEN(cPath1) == 0
     cPath1 := SUBSTR( PATH_START,1,RAT("\",PATH_START) )
   ENDIF

   IF LEN(cPath2) == 0
     cPath2 := SUBSTR( PATH_START,1,RAT("\",PATH_START) )
   ENDIF

   IF LEN(cPathPrj) == 0
     cPathPrj := PATH_START 
   ENDIF

RETURN NIL

