/* 
 * MINIGUI - Harbour Win32 GUI library  
 * 
 * Copyright 2016 Andrey Verchenko <verchenkoag@gmail.com>
*/ 
REQUEST HB_CODEPAGE_RU1251, HB_CODEPAGE_RU866
REQUEST DBFCDX, DBFFPT

#include "minigui.ch"

#define PROGRAM   " Merge projects Harbour !"
#define PVERSION  " Version 0.6 - 01.04.2016"
#define COPYRIGHT " Copyright (c) 2016, Verchenko A.G., Russia, Dmitrov. E-mail: verchenkoag@gmail.com"
#define PRG_INFO1 "Many thanks for your help: Grigory Filatov <gfilatov@inbox.ru>"
#define PRG_INFO2 "Tips and tricks programmers from our forum http://clipper.borda.ru"
#define PRG_INFO3 "SergKis, Igor Nazarov, Sidorov Aleksandr, and other..."

#define MSGINFO     1005

Function Main()
   LOCAL nFWidth, nFHeight, nHStBar
   LOCAL nImgWidth := 800, nImgHeight := 128 
   LOCAL aBackColor := { 0,176,240 }
   LOCAL cFileDbf := cFileNoPath( ChangeFileExt( Application.ExeName, ".dbf" ) )
   LOCAL cPathDbf := GetCurrentFolder() + "\BACKUP\"  

   SET EPOCH TO ( Year(Date()) - 50 )
   SET LANGUAGE TO RUSSIAN  
   SET CODEPAGE TO RUSSIAN  
   SET Date TO GERMAN
   RDDSETDEFAULT('DBFCDX')
   SET DELETED ON
   SET MULTIPLE OFF WARNING  // a ban on the launch of the second copy of the program

   IF !MyOpenDbf(cPathDbf,cFileDbf)
      QUIT
   ENDIF

     DEFINE WINDOW Form_Main ;
        AT 0, 0 ;
        WIDTH nImgWidth HEIGHT nImgHeight + 500 ;
        TITLE PROGRAM + PVERSION ; 
        ICON "1MAIN" ;
        MAIN ;
        BACKCOLOR aBackColor ;
        NOMAXIMIZE NOSIZE NOMINIMIZE ;
        ON INIT {|| OnInitForma() }  ;
        ON RELEASE { || OnCloseForma(cPathDbf,cFileDbf) } 

        nFWidth  := GetClientWidth( GetFormHandle( _HMG_ThisFormName ) )
        nFHeight := GetClientHeight( GetFormHandle( _HMG_ThisFormName ) )
        nHStBar := 20  // height StatusBar

        @ nFHeight-nHStBar,0 LABEL Label_StatusBar VALUE COPYRIGHT ;
          WIDTH nFWidth HEIGHT nHStBar SIZE 10 BOLD FONTCOLOR WHITE TRANSPARENT ;
          CENTERALIGN VCENTERALIGN ;
          ON CLICK MsgAbout(.T.)  ;
          ON MOUSEHOVER MarkerLabel(.T., RED   , aBackcolor, 12 ) ;
          ON MOUSELEAVE MarkerLabel(.F., WHITE , aBackcolor, 10 ) 

        ON KEY ESCAPE OF Form_Main ACTION ThisWindow.Release

     END WINDOW

     //Form_Main.Center
     Form_Main.Activate

Return Nil

/////////////////////////////////////////////////////////////////////
Function OnInitForma()
  
    Form_Main.Hide  // hide the main form

    IniFileYes()  // configuration file check

    Table1()  // call the main table of the program -> Form_Table.prg

    Form_Main.Release      

Return Nil

/////////////////////////////////////////////////////////////////////
Function OnCloseForma(cPath,cFileDbf)
   LOCAL cFileCdx := cFileDbf + ".cdx"

   (ALIAS())->(DbCloseArea())       // DB exit to close 

   DELETEFILE( cPath + cFileDbf )   
   DELETEFILE( ChangeFileExt( cPath + cFileDbf, ".fpt" ) ) 
   DELETEFILE( cPath + cFileCdx )   

Return Nil

/////////////////////////////////////////////////////////////////////
Function MyOpenDbf( cPath, cFileDbf )
   LOCAL aDbf := {}, nI, lRet := .F.

   AADD( aDbf , {"NN"     ,"N",  5, 0 } )
   AADD( aDbf , {"LCOPY"  ,"L",  1, 0 } )
   AADD( aDbf , {"DIR1"   ,"C",  4, 0 } )
   AADD( aDbf , {"PATH1"  ,"C", 90, 0 } )
   AADD( aDbf , {"FILE1"  ,"C", 50, 0 } )
   AADD( aDbf , {"SIZE1"  ,"N", 10, 0 } )
   AADD( aDbf , {"DATE1"  ,"D",  8, 0 } )
   AADD( aDbf , {"TIME1"  ,"C", 10, 0 } )
   AADD( aDbf , {"STATUS1","C",  6, 0 } )
   AADD( aDbf , {"DIR2"   ,"C",  4, 0 } )
   AADD( aDbf , {"PATH2"  ,"C", 90, 0 } )
   AADD( aDbf , {"FILE2"  ,"C", 50, 0 } )
   AADD( aDbf , {"SIZE2"  ,"N", 10, 0 } )
   AADD( aDbf , {"DATE2"  ,"D",  8, 0 } )
   AADD( aDbf , {"TIME2"  ,"C", 10, 0 } )
   AADD( aDbf , {"STATUS2","C",  6, 0 } )
   AADD( aDbf , {"FILEEXT","C", 10, 0 } )
   AADD( aDbf , {"RUNFUNC","C", 10, 0 } )
   //AADD( aDbf , {"FBMP"   ,"W", 10, 0 } )  // BLOB-
   AADD( aDbf , {"FBMP"   ,"M", 10, 0 } )  // MEMO-
   AADD( aDbf , {"ID"     ,"+",  8, 0 } )

   IsProgDir( cPath )

   IF !FILE( cPath + cFileDbf )
      DBCreate( cPath + cFileDbf, aDbf , "DBFCDX")
   ENDIF
   
   IF FILE( cPath + cFileDbf )
      USE ( cPath + cFileDbf ) Alias TABLE1 CODEPAGE "RU1251" VIA "DBFCDX" NEW //SHARED
      FOR nI := 1 TO 20
          APPEND BLANK
      NEXT
      lRet := .T.
   ELSE
      MsgStop("Not dBase " + cPath + cFileDbf) 
   ENDIF

Return lRet

/////////////////////////////////////////////////////////////////////////
FUNCTION IsProgDir(cPath)
   LOCAL cDir, nError, cMsg

       cDir := cPath
       IF !IsDirectory( cDir )
          nError := MakeDir( cDir )
          IF nError == 0
             cMsg := "Create a folder for the archive program !;;" + cDir
             cMsg := AtRepl( ";", cMsg, CRLF )
             MsgInfo( cMsg, 'Info!')
          ELSEIF nError == 5
             cMsg := "Directory " + cDir + " exists already"
          ELSE
            cMsg := "Error while creating a folder !;; ( DOS error "+LTrim( Str( nError ) )+" );;"
            cMsg += cDir + ";;" 
            cMsg := AtRepl( ";", cMsg, CRLF )
            MsgStop( cMsg, 'Error!')
          ENDIF
       ENDIF

RETURN NIL

///////////////////////////////////////////////////////////////////////////////////////////////////////
Function MarkerLabel(lFlag, aLabFontColor, aLabBackColor, nSize)
   LOCAL cWin  := ThisWindow.Name 
   LOCAL cCtrl := this.name
   LOCAL cStr  := GetProperty( cWin, cCtrl, "Value" )

   IF lFlag  
      Rc_Cursor( "MINIGUI_FINGER" )
      SetProperty( cWin, cCtrl, "Fontsize" , nSize   )
      SetProperty( cWin, cCtrl, "Fontcolor", aLabFontColor )
      SetProperty( cWin, cCtrl, "Backcolor", aLabBackColor )
   ELSE
      SetProperty( cWin, cCtrl, "Fontsize" , nSize  )
      SetProperty( cWin, cCtrl, "Fontcolor", aLabFontColor )
      SetProperty( cWin, cCtrl, "Backcolor", aLabBackColor )
   ENDIF
   SetProperty( cWin, cCtrl, "Value", cStr )

RETURN NIL

///////////////////////////////////////////////////////////////////////////////////////
FUNCTION MsgAbout(lMsg)
   LOCAL aDim[7]
   aDim[1] := PROGRAM 
   aDim[2] := PVERSION 
   aDim[3] := COPYRIGHT 
   aDim[4] := "Operating System: " + Os() 
   aDim[5] := "Developed in : " +  MiniGUIVersion()  
   aDim[6] := "xBase Compiler: " + Version() 
   aDim[7] := "C Compiler: " + Hb_Compiler()  

   IF lMsg
      MsgInfo( aDim[1] + CRLF + aDim[2] + CRLF + aDim[3] + CRLF + CRLF + ;
               PRG_INFO1 + CRLF + ;
               PRG_INFO2 + CRLF + ;
               PRG_INFO3 + CRLF + CRLF + ;
               aDim[4] + CRLF + aDim[5] + CRLF + aDim[6] + CRLF + ;
               aDim[7]+ CRLF + CRLF + ;
               PadC( "This program is Freeware!", 70 ) + CRLF + ;
               PadC( "Copying is allowed!", 70 ), "About", MSGINFO, .F. )
   ENDIF  

   RETURN aDim
