/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
*/

#include "minigui.ch"

//////////////////////////////////////////////////////////////////////
FUNCTION RunWinMerge() 
   LOCAL cRun, cMsg, cParam, cPath1, cPath2, cPathWM, cAlias := ALIAS()
   LOCAL aDim[3]

   IF M->nPubLang == 1
      aDim[1] := '  WinMergeU.exe !;;'
      aDim[2] := "     !;;" 
      aDim[3] := "       !;;"  
   ELSE
      aDim[1] := 'Error start WinMergeU.exe !;;'
      aDim[2] := "No file on your computer as well !;;"
      aDim[3] := "Do not set this program on your computer as well !;;"
   ENDIF

   cPath1 := ALLTRIM( (cAlias)->PATH1 ) + ALLTRIM( (cAlias)->FILE1 )
   cPath2 := ALLTRIM( (cAlias)->PATH2 ) + ALLTRIM( (cAlias)->FILE2 )
   cParam  := '"'+cPath1+'" "'+cPath2+'"'

   cPathWM := GetInstallWinMerge()
   IF LEN(cPathWM) # 0
      cRun := cPathWM + '\WinMergeU.exe'
      IF FILE(cRun)
         // Using ShellExecute for opening Explorer with selected File
         ShellExecute( , 'open', cRun, cParam, "" , 1 )
      ELSE
         cMsg := aDim[1]
         cMsg += aDim[2] 
         cMsg += cRun + ";;" 
         cMsg := AtRepl( ";", cMsg, CRLF )
         MsgStop( cMsg )
      ENDIF
   ELSE
      cMsg := aDim[1]
      cMsg += aDim[3]
      cMsg := AtRepl( ";", cMsg, CRLF )
      MsgStop( cMsg )
   ENDIF

RETURN NIL

////////////////////////////////////////////////////////////////////////
//     WinMerge    
Function GetInstallWinMerge(hKey)
   Local aInst := {}, oReg, cReg := "", oKey
   Local cName := "", nId:= 0, cPathRes := '', nJ := 0

   cReg := upper("WinMerge")

   hKey := IF(hKey == NIL, HKEY_LOCAL_MACHINE, hKey)
   oReg := TReg32():New( hKey, "Software\Microsoft\Windows\CurrentVersion\Uninstall" )

   While RegEnumKey( oReg:nHandle, nId++, @cReg ) == 0
         oKey := TReg32():New( hKey, "Software\Microsoft\Windows\CurrentVersion\Uninstall\" + cReg )
         cName := oKey:Get("DisplayIcon")
         if !empty(cname) .and. AT(cReg,upper(cname)) > 0
            cPathRes := cname
         endif
         oKey:Close()
   End

   IF !empty(cPathRes) //  
     cPathRes := win_regRead( "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\WinMerge_is1\Inno Setup: App Path")
   ENDIF

Return cPathRes

//////////////////////////////////////////////////////////////////////

#pragma BEGINDUMP

#define _WIN32_WINNT   0x0400
#include <shlobj.h>

#include <windows.h>
#include <commctrl.h>
#include "hbapi.h"

HB_FUNC ( REGENUMKEY )
{
   BYTE buffer[ 128 ];
   hb_retnl( RegEnumKey( ( HKEY ) hb_parnl( 1 ), hb_parnl( 2 ), buffer, 128 ) );
   hb_storc( buffer, 3 );
}

#pragma ENDDUMP