/*
 * MINIGUI - Harbour Win32 GUI library 
 *
 * Team library offline http://clipper.borda.ru/ 
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2015-2016 SergKis  http://clipper.borda.ru
*/

#include "minigui.ch"

// GetCellSize( oBrw, nRowPos, nCell, lColSpecHd ) //     TsBrowse
// SetNoHoles( oBrw )          //      
// TableInfoSuperHeader(oBrw)  // :  
// TableInfoSize(oBrw)         // :        
// TableInfoCell(oBrw)         // :   

///////////////////////////////////////////////////////////////////////////////
//     TsBrowse
Function GetCellSize( oBrw, nRowPos, nCell, lColSpecHd ) 
LOCAL nI, ix, nStartX := 0, oCol, cBrw, cForm
LOCAL nRow, nCol, nWidth, nHeight

   Default nRowPos    := oBrw:nRowPos, ;
           nCell      := oBrw:nCell, ;
           lColSpecHd := .F.

   cForm := oBrw:cParentWnd
   cBrw  := oBrw:cControlName
   oCol  := oBrw:aColumns[ nCell ]

   If oBrw:nFreeze > 0
      For nI := 1 To Min( oBrw:nFreeze , nCell - 1 )
         nStartX += oBrw:GetColSizes()[ nI ]
      Next
   EndIf

   For nI := oBrw:nColPos To nCell - 1
      nStartX += oBrw:GetColSizes()[ nI ]
   Next

   IF lColSpecHd                  //   SpecHeader
      nRow    := oBrw:nHeightHead + oBrw:nHeightSuper + If( oCol:l3DLook, 2, 0 )
      nCol    := nStartX + If( oCol:l3DLook, 2, 0 )
      nWidth  := oBrw:GetColSizes()[ nCell ] - If( oCol:l3DLook, 2, 1 )
      nHeight := oBrw:nHeightSpecHd - If( oCol:l3DLook, 1, -1 )
   else                           //   
      nRow    := nRowPos - 1
      nRow    := ( nRow * oBrw:nHeightCell ) + oBrw:nHeightHead + ;
                 oBrw:nHeightSuper + oBrw:nHeightSpecHd + If( oCol:l3DLook, 2, 0 )
      nCol    := nStartX + If( oCol:l3DLook, 2, 0 )
      nWidth  := oBrw:GetColSizes()[ nCell ] - If( oCol:l3DLook, 2, 0 )
      nHeight := oBrw:nHeightCell - If( oCol:l3DLook, 1, -1 )
   endif

   ix := GetControlIndex ( cBrw, cForm )     //     
   if _HMG_aControlContainerRow [ix] == -1   // TGETBOX !!!
      nRow += oBrw:nTop - 1
      nCol += oBrw:nLeft
   else
      nRow += _HMG_aControlRow [ix] - 1
      nCol += _HMG_aControlCol [ix]
   endif

   nRow    += oBrw:aEditCellAdjust[1]
   nCol    += oBrw:aEditCellAdjust[2]
   nWidth  += oBrw:aEditCellAdjust[3] + 2
   nHeight += oBrw:aEditCellAdjust[4] + 2

Return { nRow, nCol, nWidth, nHeight }

////////////////////////////////////////////////////////////////////
//      
FUNCTION SetNoHoles( oBrw, nHScrollHeight, nDelta ) 
    LOCAL nI, nK, nHeight, nHole

    DEFAULT nHScrollHeight := GetHScrollBarHeight()-1 //   
    DEFAULT nDelta := 1   //  2, .       
    
    nHole := oBrw:nHeight - oBrw:nHeightHead - oBrw:nHeightSuper - ; 
             oBrw:nHeightFoot - oBrw:nHeightSpecHd - ;
             If( oBrw:lNoHScroll, 0, nHScrollHeight ) 

    nHole   -= ( Int( nHole / oBrw:nHeightCell ) * oBrw:nHeightCell )
    nHole   -= nDelta
    nHeight := nHole
   
    nI := If( oBrw:nHeightSuper  > 0, 1, 0 ) + ;
          If( oBrw:nHeightHead   > 0, 1, 0 ) + ;
          If( oBrw:nHeightSpecHd > 0, 1, 0 ) + ;
          If( oBrw:nHeightFoot   > 0, 1, 0 )
          
    If nI > 0                          //  
   
       nK := int( nHole / nI )         //  nI -   
   
       If oBrw:nHeightFoot   > 0
          oBrw:nHeightFoot   += nK
          nHole              -= nK
       EndIf
       If oBrw:nHeightSuper  > 0
          oBrw:nHeightSuper  += nK
          nHole              -= nK
       EndIf
       If oBrw:nHeightSpecHd > 0
          oBrw:nHeightSpecHd += nK
          nHole              -= nK
       EndIf
       If oBrw:nHeightHead   > 0
          oBrw:nHeightHead   += nHole
       EndIf
   
    Else             //  ,    tsb   nHole
   
       SetProperty(oBrw:cParentWnd, oBrw:cControlName, "Height", ;
       GetProperty(oBrw:cParentWnd, oBrw:cControlName, "Height") - nHole)
   
    EndIf
   
    oBrw:Display()

RETURN nHeight

//////////////////////////////////////////////////////////////////////
//    
FUNCTION TableInfoSuperHeader(oBrw1) 
    LOCAL nI, cMsg, cRet, aDim, cTitle
 
    //MsgDebug(oBrw1:aSuperHead, oBrw1:nHeightSuper)
    cMsg := Replicate( "-._.", 22 ) + CRLF + CRLF
    aDim := oBrw1:aSuperHead
    IF LEN(aDim) > 0
       For nI := 1 To LEN(aDim)
          cRet := STR(nI) + ") - : " + HB_NtoS(aDim[nI,1]) + " : " + HB_NtoS(aDim[nI,2])
          cTitle := ALLTRIM(aDim[nI,3])
          cTitle := STRTRAN(cTitle,CHR(10),"")
          cTitle := STRTRAN(cTitle,CHR(13),"") 
          cTitle := STRTRAN(cTitle,"\n","") 
          cRet += ' , ' + cTitle 
          cMsg += cRet  + CRLF + CRLF
       Next 
    ELSE
      cMsg += '    !' + CRLF + CRLF
    ENDIF 
    cMsg += "oBrw1:nHeightSuper=" + HB_NtoS(oBrw1:nHeightSuper) + CRLF + CRLF
    cMsg += Replicate( "-._.", 22 ) + CRLF + CRLF
    MsgInfo(cMsg,":   " + (oBrw1:cAlias))
   
    RETURN Nil

//////////////////////////////////////////////////////////////////////
FUNCTION TableInfoCell(oBrw1) 
    LOCAL nI, cMsg, cRet

    cMsg := Replicate( "-._.", 22 ) + CRLF + CRLF
    For nI := 1 To oBrw1:nColCount()
       cRet := oBrw1:aColumns[nI]:cHeading
       cRet := STRTRAN(cRet,CHR(10),"") 
       cRet := STRTRAN(cRet,CHR(13)," ") 
       cRet := STRTRAN(cRet,'-',"") 
       cMsg += STR(nI,2) + ' "' + cRet +'"  - ' 
       cMsg += HB_NtoS(oBrw1:GetColSizes()[nI]) + CRLF 
    Next 
    cMsg += Replicate( "-._.", 22 ) + CRLF + CRLF
    MsgInfo(cMsg,":    "+ (oBrw1:cAlias))
   
    RETURN Nil

//////////////////////////////////////////////////////////////////////
FUNCTION TableInfoSize(oBrw1) 
    LOCAL cMsg

    cMsg := " / LargeFont() = " + XTOC(LargeFonts()) + CRLF + CRLF
    cMsg += Replicate( "-._.", 22 ) + CRLF + CRLF
    cMsg += "1) Height = " + HB_NtoS(oBrw1:nHeight) + CRLF
    cMsg += "2) HeightHead = " + HB_NtoS(oBrw1:nHeightHead) + CRLF
    cMsg += "3) HeightSuper = " + HB_NtoS(oBrw1:nHeightSuper) + CRLF
    cMsg += "4) HeightFoot = " + HB_NtoS(oBrw1:nHeightFoot) + CRLF
    cMsg += "5) HeightSpecHd = " + HB_NtoS(oBrw1:nHeightSpecHd) + CRLF
    cMsg += "6) HeightCell = " + HB_NtoS(oBrw1:nHeightCell) + CRLF + CRLF
    cMsg += "Number of rows in the table = " + HB_NtoS(oBrw1:nRowCount()) + CRLF + CRLF 
    cMsg += "GetHScrollBarHeight() = " + HB_NtoS(GetHScrollBarHeight()) + CRLF 
    cMsg += "GetVScrollBarWidth() = " + HB_NtoS(GetVScrollBarWidth()) + CRLF 
    cMsg += Replicate( "-._.", 22 ) + CRLF + CRLF
    MsgInfo(cMsg,":    " + (oBrw1:cAlias))

    RETURN Nil

